SystemOrganization addCategory: #'Uko-HW4'!
SystemOrganization addCategory: #'Uko-HW4-Tests'!

!Number methodsFor: '*uko-hw4' stamp: 'YuriyTymchuk 4/5/2012 10:49'!
power: pow 
	|result|
	result := 1.
	pow timesRepeat: [result := result * self].
	^result ! !

Object subclass: #Task2
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-HW4'!

!Task2 methodsFor: 'support' stamp: 'YuriyTymchuk 4/5/2012 10:58'!
a
	^x squared / 2 factorial - ((x power:4)  / 4 factorial ) + ((x power:6) / 6 factorial )! !

!Task2 methodsFor: 'as yet unclassified' stamp: 'YuriyTymchuk 4/5/2012 11:16'!
b
	^(Float pi * 3 / 4) sin + (x * z cos) - (z * y cos) + (y * x cos).! !

!Task2 methodsFor: 'as yet unclassified' stamp: 'YuriyTymchuk 4/5/2012 11:19'!
c
	^5* ((x * z cos) - (z * y cos) + (y * x cos)).! !

!Task2 methodsFor: 'as yet unclassified' stamp: 'YuriyTymchuk 4/5/2012 02:00'!
initializeWithX: xParam Y: yParam Z: zParam
	self initialize.
	x := xParam.
	y := yParam.
	z := zParam! !

!Task2 methodsFor: 'as yet unclassified' stamp: 'YuriyTymchuk 4/5/2012 11:26'!
maximin
	^self a max: (self b min: self c)! !

!Integer methodsFor: '*uko-hw4' stamp: 'YuriyTymchuk 4/4/2012 19:44'!
digits
	^self asString asArray collect: [:each | each asString asNumber].! !

!Integer methodsFor: '*uko-hw4' stamp: 'YuriyTymchuk 4/4/2012 19:43'!
equalOddAndEven
	|odd even|
	odd := self digits select: [ :each| (each \\ 2) = 1].
	even := self digits select: [ :each| (each \\ 2) = 0].
	^odd size = even size! !

!Integer methodsFor: '*uko-hw4' stamp: 'YuriyTymchuk 4/4/2012 19:43'!
hasMoreEvenDigits
	|odd even|
	odd := self digits select: [ :each| (each \\ 2) = 1].
	even := self digits select: [ :each| (each \\ 2) = 0].
	^odd size < even size! !

!Integer methodsFor: '*uko-hw4' stamp: 'YuriyTymchuk 4/4/2012 19:43'!
hasMoreOddDigits
	|odd even|
	odd := self digits select: [ :each| (each \\ 2) = 1].
	even := self digits select: [ :each| (each \\ 2) = 0].
	^odd size > even size! !

TestCase subclass: #HW4IntegerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-HW4-Tests'!

!HW4IntegerTests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/4/2012 19:41'!
testEqualOddAndEven
	self assert: (123 equalOddAndEven not).
	self assert: (223 equalOddAndEven not).
	self assert: (1223 equalOddAndEven).! !

!HW4IntegerTests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/4/2012 19:41'!
testHasMoreEvenDigits
	self assert: (112 hasMoreEvenDigits not).
	self assert: (221 hasMoreEvenDigits).
	self assert: (2211 hasMoreEvenDigits not)! !

!HW4IntegerTests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/4/2012 19:41'!
testHasMoreOddDigits
	self assert: (112 hasMoreOddDigits).
	self assert: (221 hasMoreOddDigits not).
	self assert: (2211 hasMoreOddDigits not)	! !

TestCase subclass: #HW4NumberTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-HW4-Tests'!

!HW4NumberTests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/5/2012 10:55'!
testPower
	self assert: ((5 power: 2) = 25).
	self assert: ((3 power: 3) = 27).
	self assert: ((2 power: 10) = 1024).! !

TestCase subclass: #Task2Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Uko-HW4-Tests'!

!Task2Tests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/5/2012 11:01'!
testA
	self assert: ((Task2 new initializeWithX: 0 Y: 0 Z: 0) a = (0/720)).
	self assert: ((Task2 new initializeWithX: 1 Y: 0 Z: 0) a = (331/720)).
! !

!Task2Tests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/5/2012 11:17'!
testB
	self assert: ((Task2 new initializeWithX: 0 Y: 0 Z: 0) b = (Float pi *3 /4) sin).
	self assert: ((Task2 new initializeWithX: Float pi Y: Float pi Z: Float pi) b = ((Float pi *3 /4) sin - Float pi)).
	 ! !

!Task2Tests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/5/2012 11:21'!
testC
	self assert: ((Task2 new initializeWithX: 0 Y: 0 Z: 0) c = 0).
	self assert: ((Task2 new initializeWithX: Float pi Y: Float pi Z: Float pi) c = (-5* Float pi)).! !

!Task2Tests methodsFor: 'tests' stamp: 'YuriyTymchuk 4/5/2012 11:30'!
testMaximin
	self assert: ((Task2 new initializeWithX: 0 Y: 0 Z: 0) maximin = 0).
	self assert: ((Task2 new initializeWithX: Float pi Y: Float pi Z: Float pi) maximin =(Task2 new initializeWithX: Float pi Y: Float pi Z: Float pi) a).
	self assert: ((Task2 new initializeWithX: 1 Y: 1 Z: 1) maximin = (Task2 new initializeWithX: 1 Y: 1 Z: 1) b).! !
